/*
 * CellXView.java
 *
 * Copyright (C) 2011 Christian Mayer
 *
 * This file is part of CellXGui
 *
 */

/*
 * CellXView.java
 *
 * Created on Dec 9, 2011, 2:57:33 PM
 */
package cellxgui.view;

import cellxgui.controller.CellXController;
import cellxgui.controller.CellXGuiConfiguration;
import cellxgui.controller.CellXGuiConfiguration.Mode;
import cellxgui.controller.CellXParameter;
import cellxgui.model.shapes.SelectableShape;
import cellxgui.model.signalaligner.XYMembraneProfile;
import cellxgui.view.dialogs.CellXGuiSettingsDialog;
import cellxgui.view.membranesignalpanel.MembraneChartPanel;
import cellxgui.view.membranesignalpanel.MembranePanelMouseAdapter;
import cellxgui.view.tables.AutoButtonHandler;
import cellxgui.view.tables.CellXTableView;
import cellxgui.view.zoomimagepanel.ExtendedZoomImagePanel;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableModel;
import org.jfree.ui.HorizontalAlignment;

/**
 *
 * @author Christian Mayer <chrixian.mayer@gmail.com>
 */
public class CellXView extends javax.swing.JFrame implements AbstractView {

    private final static int maxWinElongation = 600;
    private final CellXController controller;
    private final ExtendedZoomImagePanel zoomImagePanel;
    private final MembraneChartPanel membraneProfilePanel;
    private ListSelectionListener lsl;
    private final CellXTableView paramTableView;
    private final CellXTableView advancedParamTableView;
    private final CellXGuiSettingsDialog settingsDialog;
    private final BatchProcessPanel batchView;
    private final RecentImagesMenu controlImageMenu;

    /**
     * Creates new form CellXView
     */
    public CellXView(CellXController controller, BatchProcessPanel batchView) {

        this.controller = controller;

        initComponents();

        this.setTitle("CellX");

        this.zoomImagePanel = new ExtendedZoomImagePanel(controller);
        this.membraneProfilePanel = new MembraneChartPanel();
        this.membraneProfilePanel.setPreferredSize(new Dimension(600, 200));
        final MembranePanelMouseAdapter mpma = new MembranePanelMouseAdapter(controller, membraneProfilePanel);
        this.membraneProfilePanel.addMouseListener(mpma);
        this.membraneProfilePanel.addMouseMotionListener(mpma);

        this.membraneProfilePanel.setPopupMenu(null);

        imagePanel.add(zoomImagePanel);
        chartPanel.add(membraneProfilePanel);

        initToolbarListener();

        initListListener();


        paramTableView = new CellXTableView();

        advancedParamTableView = new CellXTableView();


        initTableViewButtonActionListeners();


        jScrollPane2.setViewportView(paramTableView);
        jScrollPane3.setViewportView(advancedParamTableView);

        this.settingsDialog = new CellXGuiSettingsDialog(this, true, controller.getProperties());
        controller.getProperties().addPropertyChangeListener(this.settingsDialog);

        this.batchView = batchView;
        batchBasePanel.add(batchView);

        controlImageMenu = (RecentImagesMenu) jMenu3;

        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        
        initAboutMenu();
       

        this.setLocationRelativeTo(null);
        pack();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        toolbarBtnGroup = new javax.swing.ButtonGroup();
        notificationPanel = new javax.swing.JPanel();
        notificationLabel = new javax.swing.JLabel();
        mainScrollPanel = new javax.swing.JScrollPane();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        centralPanel = new javax.swing.JPanel();
        imagePanel = new javax.swing.JPanel();
        chartPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        shapesList = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        zoomAndPanBtn = new javax.swing.JToggleButton();
        membraneProfileBtn = new javax.swing.JToggleButton();
        maxCellLengthBtn = new javax.swing.JToggleButton();
        seedSizeBtn = new javax.swing.JToggleButton();
        cropBtn = new javax.swing.JToggleButton();
        jLabel2 = new javax.swing.JLabel();
        testHoughBtn = new javax.swing.JButton();
        testSegmentationBtn = new javax.swing.JButton();
        fluoImageBtn = new javax.swing.JButton();
        flatFieldImageBtn = new javax.swing.JButton();
        fluoImageTF = new javax.swing.JTextField();
        flatFieldImageTF = new javax.swing.JTextField();
        batchBasePanel = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        openImageMenuItm = new javax.swing.JMenuItem();
        openProjectMenuItm = new javax.swing.JMenuItem();
        importParametersMenuItm = new javax.swing.JMenuItem();
        newProjectMenuItm = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        saveProjectMenuItm = new javax.swing.JMenuItem();
        exportParamsMenuItm = new javax.swing.JMenuItem();
        exportFilesetsMenuItm = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenu3 = new RecentImagesMenu(this, this.controller);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        notificationPanel.setBackground(new java.awt.Color(102, 102, 102));
        notificationPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        notificationPanel.setFocusable(false);
        notificationPanel.setPreferredSize(new java.awt.Dimension(1134, 20));
        notificationPanel.setRequestFocusEnabled(false);
        notificationPanel.setLayout(new javax.swing.BoxLayout(notificationPanel, javax.swing.BoxLayout.LINE_AXIS));

        notificationLabel.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        notificationLabel.setForeground(new java.awt.Color(204, 204, 204));
        notificationLabel.setFocusable(false);
        notificationLabel.setRequestFocusEnabled(false);
        notificationLabel.setVerifyInputWhenFocusTarget(false);
        notificationPanel.add(notificationLabel);

        getContentPane().add(notificationPanel, java.awt.BorderLayout.SOUTH);

        mainScrollPanel.setPreferredSize(new java.awt.Dimension(1120, 890));

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(1105, 800));
        jTabbedPane1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTabbedPane1KeyTyped(evt);
            }
        });

        centralPanel.setPreferredSize(new java.awt.Dimension(1100, 860));

        imagePanel.setMaximumSize(new java.awt.Dimension(600, 600));
        imagePanel.setMinimumSize(new java.awt.Dimension(600, 600));
        imagePanel.setPreferredSize(new java.awt.Dimension(600, 600));
        imagePanel.setLayout(null);

        chartPanel.setPreferredSize(new java.awt.Dimension(600, 250));
        chartPanel.setLayout(new javax.swing.BoxLayout(chartPanel, javax.swing.BoxLayout.LINE_AXIS));

        jScrollPane1.setMinimumSize(new java.awt.Dimension(259, 100));

        jScrollPane1.setViewportView(shapesList);

        jScrollPane2.setPreferredSize(new java.awt.Dimension(281, 138));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, "", null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Parameter", "Value", "Title 3", "Title 4"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, true, true, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setPreferredSize(new java.awt.Dimension(300, 140));
        jScrollPane2.setViewportView(jTable1);

        jScrollPane3.setPreferredSize(new java.awt.Dimension(281, 218));

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Parameter", "Value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane3.setViewportView(jTable2);

        jLabel1.setText("General Parameters");

        toolbarBtnGroup.add(zoomAndPanBtn);
        zoomAndPanBtn.setSelected(true);
        zoomAndPanBtn.setFocusable(false);
        zoomAndPanBtn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        zoomAndPanBtn.setLabel("Zoom/Pan");
        zoomAndPanBtn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        toolbarBtnGroup.add(membraneProfileBtn);
        membraneProfileBtn.setFocusable(false);
        membraneProfileBtn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        membraneProfileBtn.setLabel("Membrane Profile");
        membraneProfileBtn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        toolbarBtnGroup.add(maxCellLengthBtn);
        maxCellLengthBtn.setText("Maximum Cell Length");
        maxCellLengthBtn.setActionCommand("MaxCellLength");
        maxCellLengthBtn.setFocusable(false);
        maxCellLengthBtn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        maxCellLengthBtn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        toolbarBtnGroup.add(seedSizeBtn);
        seedSizeBtn.setFocusable(false);
        seedSizeBtn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        seedSizeBtn.setLabel("Seed Size");
        seedSizeBtn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        toolbarBtnGroup.add(cropBtn);
        cropBtn.setText("Crop");
        cropBtn.setFocusable(false);
        cropBtn.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        cropBtn.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        jLabel2.setText("Advanced Parameters");

        testHoughBtn.setText("Test Seeding");
        testHoughBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testHoughBtnActionPerformed(evt);
            }
        });

        testSegmentationBtn.setText("Test Segmentation");
        testSegmentationBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testSegmentationBtnActionPerformed(evt);
            }
        });

        fluoImageBtn.setText("Quantification Image");
        fluoImageBtn.setToolTipText("Select fluorescence image on which the segmentation mask will be displayed");
        fluoImageBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fluoImageBtnActionPerformed(evt);
            }
        });

        flatFieldImageBtn.setText("Flat Field Image");
        flatFieldImageBtn.setToolTipText("Optional flat field image for correction of the fluorescence image");
        flatFieldImageBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                flatFieldImageBtnActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout centralPanelLayout = new javax.swing.GroupLayout(centralPanel);
        centralPanel.setLayout(centralPanelLayout);
        centralPanelLayout.setHorizontalGroup(
            centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(centralPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(imagePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(chartPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(30, 30, 30)
                .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, centralPanelLayout.createSequentialGroup()
                        .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, centralPanelLayout.createSequentialGroup()
                                .addComponent(testHoughBtn)
                                .addGap(18, 18, 18)
                                .addComponent(testSegmentationBtn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 157, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, centralPanelLayout.createSequentialGroup()
                                .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(zoomAndPanBtn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(cropBtn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(membraneProfileBtn, 0, 0, Short.MAX_VALUE)
                                    .addComponent(maxCellLengthBtn, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(seedSizeBtn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGap(29, 29, 29)
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, centralPanelLayout.createSequentialGroup()
                                .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(fluoImageBtn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(flatFieldImageBtn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(flatFieldImageTF, javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(fluoImageTF))))
                        .addGap(33, 33, 33))
                    .addGroup(centralPanelLayout.createSequentialGroup()
                        .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1))
                        .addContainerGap())))
        );
        centralPanelLayout.setVerticalGroup(
            centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(centralPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(centralPanelLayout.createSequentialGroup()
                        .addComponent(imagePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(chartPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(centralPanelLayout.createSequentialGroup()
                        .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(centralPanelLayout.createSequentialGroup()
                                .addGap(12, 12, 12)
                                .addComponent(zoomAndPanBtn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(seedSizeBtn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(maxCellLengthBtn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(membraneProfileBtn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cropBtn))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 184, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(26, 26, 26)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 244, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(testHoughBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(testSegmentationBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(fluoImageBtn)
                            .addComponent(fluoImageTF, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(centralPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(flatFieldImageTF, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(flatFieldImageBtn))))
                .addGap(13, 13, 13))
        );

        jTabbedPane1.addTab("Calibration", centralPanel);

        batchBasePanel.setPreferredSize(new java.awt.Dimension(300, 300));
        batchBasePanel.setLayout(new javax.swing.BoxLayout(batchBasePanel, javax.swing.BoxLayout.PAGE_AXIS));
        jTabbedPane1.addTab("Batch Processing", batchBasePanel);

        mainScrollPanel.setViewportView(jTabbedPane1);

        getContentPane().add(mainScrollPanel, java.awt.BorderLayout.CENTER);

        jMenu1.setText("File");

        openImageMenuItm.setText("Open Segmentation Image");
        openImageMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openImageMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(openImageMenuItm);

        openProjectMenuItm.setText("Open Project");
        openProjectMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openProjectMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(openProjectMenuItm);

        importParametersMenuItm.setText("Import Parameters");
        importParametersMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importParametersMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(importParametersMenuItm);

        newProjectMenuItm.setText("New Project");
        newProjectMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newProjectMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(newProjectMenuItm);
        jMenu1.add(jSeparator1);

        saveProjectMenuItm.setText("Save Project");
        saveProjectMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveProjectMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(saveProjectMenuItm);

        exportParamsMenuItm.setMnemonic('S');
        exportParamsMenuItm.setText("Export Parameters");
        exportParamsMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportParamsMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(exportParamsMenuItm);

        exportFilesetsMenuItm.setText("Export File Series");
        exportFilesetsMenuItm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportFilesetsMenuItmActionPerformed(evt);
            }
        });
        jMenu1.add(exportFilesetsMenuItm);
        jMenu1.add(jSeparator2);

        jMenuItem3.setText("Settings");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);
        jMenu1.add(jSeparator3);

        jMenuItem1.setText("Quit");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        jMenu3.setText("Control images");
        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void openImageMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openImageMenuItmActionPerformed

        final JFileChooser fc = new JFileChooser();
        fc.setMultiSelectionEnabled(false);

        if (controller.getProperties().hasImageDir()) {
            final File f = controller.getProperties().getImageDir();
            if (f!=null && f.exists() && f.isDirectory()) {
                fc.setCurrentDirectory(f);
            }
        }
        final int ret = fc.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION && fc.getSelectedFile() != null) {
            controller.loadImage(fc.getSelectedFile());
            controller.getProperties().setImageDir(fc.getSelectedFile().getParent());
        }
    }//GEN-LAST:event_openImageMenuItmActionPerformed

    private void exportParamsMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportParamsMenuItmActionPerformed

        if (this.controller.hasInvalidParameter()) {
            return;
        }

        final File file = askXMLFileName();
        if (file != null) {
            this.controller.saveConfigToXML(file);
        }

    }//GEN-LAST:event_exportParamsMenuItmActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        settingsDialog.setVisible(true);
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void testHoughBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testHoughBtnActionPerformed
        controller.runCellXHoughTransform();
    }//GEN-LAST:event_testHoughBtnActionPerformed

    private void testSegmentationBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testSegmentationBtnActionPerformed
        controller.runCellXSegmentation();
    }//GEN-LAST:event_testSegmentationBtnActionPerformed

    private void saveProjectMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveProjectMenuItmActionPerformed
        // TODO add your handling code here:
        final JFileChooser jfc = new JFileChooser();
        jfc.setMultiSelectionEnabled(false);
        final CellXProjectFileFilter cxff = new CellXProjectFileFilter();
        jfc.addChoosableFileFilter(cxff);
        jfc.setFileFilter(jfc.getChoosableFileFilters()[1]);

        if (controller.getProperties().hasProjectDir()) {
            final File f = controller.getProperties().getProjectDir();
            if (f.exists() && f.isDirectory()) {
                jfc.setCurrentDirectory(f);
            }
        }


        final int ret = jfc.showSaveDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            File f = jfc.getSelectedFile();
            if (!f.toString().endsWith(CellXProjectFileFilter.FILE_EXTENSION) && jfc.getFileFilter() == cxff.getFileFilter()) {
                f = new File(f.toString() + CellXProjectFileFilter.FILE_EXTENSION);
            }
            if (f.exists()) {
                final int aw = JOptionPane.showConfirmDialog(this, "File '" + f.toString() + "' exists, do you want to overwrite?", "File exists", JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE);
                if (aw != JOptionPane.OK_OPTION) {
                    return;
                }
            }
            this.controller.saveProject(f);
        }

    }//GEN-LAST:event_saveProjectMenuItmActionPerformed

    private void openProjectMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openProjectMenuItmActionPerformed
        // TODO add your handling code here:
        final JFileChooser jfc = new JFileChooser();
        jfc.setMultiSelectionEnabled(false);
        final CellXProjectFileFilter cxff = new CellXProjectFileFilter();
        jfc.addChoosableFileFilter(cxff);
        jfc.setFileFilter(jfc.getChoosableFileFilters()[1]);

        if (controller.getProperties().hasProjectDir()) {
            final File f = controller.getProperties().getProjectDir();
            if (f.exists() && f.isDirectory()) {
                jfc.setCurrentDirectory(f);
            }
        }

        final int ret = jfc.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION && jfc.getSelectedFile() != null) {
            final File f = jfc.getSelectedFile();
            this.controller.loadProject(f);
        }
    }//GEN-LAST:event_openProjectMenuItmActionPerformed

    private void newProjectMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newProjectMenuItmActionPerformed
        controller.createEmptyProject();
    }//GEN-LAST:event_newProjectMenuItmActionPerformed

    private void exportFilesetsMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportFilesetsMenuItmActionPerformed

        final int selected[] = batchView.getSelectedIndicesOfFileSeries();
        if (selected.length == 0) {
            JOptionPane.showMessageDialog(this, "No time series selected.", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        final File file = askXMLFileName();
        controller.saveFileSeriesToXML(file, selected);
    }//GEN-LAST:event_exportFilesetsMenuItmActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        controller.close();
    }//GEN-LAST:event_formWindowClosing

    private void fluoImageBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fluoImageBtnActionPerformed
        final JFileChooser jfc = new JFileChooser();
        jfc.setApproveButtonText("Select");
        jfc.setDialogTitle("Select fluorescence image");
        jfc.setMultiSelectionEnabled(false);
        File f = new File(fluoImageTF.getText());
        if (f.exists()) {
            jfc.setSelectedFile(f);
        } else {
            f = controller.getCurrentImage();
            if (f != null && f.exists()) {
                jfc.setCurrentDirectory(f);
            } else {
                if (controller.getProperties().hasImageDir()) {
                    f = controller.getProperties().getImageDir();
                    if (f!=null && f.exists()) {
                        jfc.setCurrentDirectory(f);
                    }
                }
            }
        }
        final int r = jfc.showOpenDialog(this);
        if (r == JFileChooser.APPROVE_OPTION) {
            controller.setFluoImage(jfc.getSelectedFile());
        }
    }//GEN-LAST:event_fluoImageBtnActionPerformed

    private void flatFieldImageBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flatFieldImageBtnActionPerformed
        final JFileChooser jfc = new JFileChooser();
        jfc.setApproveButtonText("Select");
        jfc.setDialogTitle("Select flat field image");
        jfc.setMultiSelectionEnabled(false);
        File f = new File(flatFieldImageTF.getText());
        if (f.exists()) {
            jfc.setSelectedFile(f);
        } else {
            f = new File(fluoImageTF.getText());
            if (f.exists()) {
                jfc.setSelectedFile(f);
            } else {
                f = controller.getCurrentImage();
                if (f != null && f.exists()) {
                    jfc.setCurrentDirectory(f);
                } else {
                    if (controller.getProperties().hasImageDir()) {
                        f = controller.getProperties().getImageDir();
                        if (f!=null && f.exists()) {
                            jfc.setCurrentDirectory(f);
                        }
                    }
                }
            }
        }
        final int r = jfc.showOpenDialog(this);
        if (r == JFileChooser.APPROVE_OPTION) {
            controller.setFlatFieldImage(jfc.getSelectedFile());
        }
    }//GEN-LAST:event_flatFieldImageBtnActionPerformed

    private void importParametersMenuItmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importParametersMenuItmActionPerformed
        final JFileChooser jfc = new JFileChooser();
        jfc.setApproveButtonText("Select");
        jfc.setDialogTitle("Select CellX XML parameters");
        jfc.setMultiSelectionEnabled(false);
        if (controller.getProperties().hasImageDir()) {
            final File f = controller.getProperties().getImageDir();
            if (f!=null && f.exists()) {
                jfc.setCurrentDirectory(f);
            }
        }
        final int r = jfc.showOpenDialog(this);
        if (r == JFileChooser.APPROVE_OPTION) {
            controller.importParameters(jfc.getSelectedFile());
        }
    }//GEN-LAST:event_importParametersMenuItmActionPerformed

    private void jTabbedPane1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTabbedPane1KeyTyped
        // TODO add your handling code here:
        final String s = String.valueOf(evt.getKeyChar()).toLowerCase();
        if (s.equals("a")) {
            zoomImagePanel.setAntiAliasingEnabled(true);
        }

        if (s.equals("s")) {
            zoomImagePanel.setAntiAliasingEnabled(false);
        }

        zoomImagePanel.repaint();
    }//GEN-LAST:event_jTabbedPane1KeyTyped

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // TODO add your handling code here:
        controller.close();
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel batchBasePanel;
    private javax.swing.JPanel centralPanel;
    private javax.swing.JPanel chartPanel;
    private javax.swing.JToggleButton cropBtn;
    private javax.swing.JMenuItem exportFilesetsMenuItm;
    private javax.swing.JMenuItem exportParamsMenuItm;
    private javax.swing.JButton flatFieldImageBtn;
    private javax.swing.JTextField flatFieldImageTF;
    private javax.swing.JButton fluoImageBtn;
    private javax.swing.JTextField fluoImageTF;
    private javax.swing.JPanel imagePanel;
    private javax.swing.JMenuItem importParametersMenuItm;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JScrollPane mainScrollPanel;
    private javax.swing.JToggleButton maxCellLengthBtn;
    private javax.swing.JToggleButton membraneProfileBtn;
    private javax.swing.JMenuItem newProjectMenuItm;
    private javax.swing.JLabel notificationLabel;
    private javax.swing.JPanel notificationPanel;
    private javax.swing.JMenuItem openImageMenuItm;
    private javax.swing.JMenuItem openProjectMenuItm;
    private javax.swing.JMenuItem saveProjectMenuItm;
    private javax.swing.JToggleButton seedSizeBtn;
    private javax.swing.JList shapesList;
    private javax.swing.JButton testHoughBtn;
    private javax.swing.JButton testSegmentationBtn;
    private javax.swing.ButtonGroup toolbarBtnGroup;
    private javax.swing.JToggleButton zoomAndPanBtn;
    // End of variables declaration//GEN-END:variables

    @Override
    //@SuppressWarnings("unchecked")
    public void modelPropertyChange(PropertyChangeEvent evt) {
        Logger.getLogger(this.getClass().getName()).log(Level.FINE, "VIEW: Received property change: {0}", evt);
        if (evt.getPropertyName().equals(CellXController.IMAGE_PROPERTY)) {
            if (evt.getNewValue() instanceof BufferedImage) {
                setNewImage((BufferedImage) evt.getNewValue());
            } else {
                throw new InternalError("Unexpected value for property '" + CellXController.IMAGE_PROPERTY + "', found '" + evt.getNewValue() + "'");
            }
            flatFieldImageTF.setText("");
            fluoImageTF.setText("");
        } else if (evt.getPropertyName().equals(CellXController.IMAGE_PANEL_MODE)) {
            if (evt.getNewValue() instanceof Mode) {
                modelPropertyChangeImagePanelMode((Mode) evt.getNewValue());
            } else {
                throw new InternalError("Unexpected value for property '" + CellXController.IMAGE_PANEL_MODE + "', found '" + evt.getNewValue() + "'");
            }
        } else if (evt.getPropertyName().equals(CellXController.LIST_BOX_MODEL)) {
            if (evt.getNewValue() instanceof List<?>) {
                setShapesList((List<SelectableShape>) evt.getNewValue());
            }
        } else if (evt.getPropertyName().equals(CellXController.MEMBRANE_PROFILE)) {
            if (evt.getNewValue() instanceof XYMembraneProfile) {
                final XYMembraneProfile profile = (XYMembraneProfile) evt.getNewValue();
                membraneProfilePanel.updateDataSet(profile);
            }
        } else if (evt.getPropertyName().equals(CellXController.OVERLAY_CHANGE)) {
            zoomImagePanel.repaint();
        } else if (evt.getPropertyName().equals(CellXController.PARAM_TABLE_MODEL_CHANGE)) {
            paramTableView.setModel((TableModel) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.ADV_PARAM_TABLE_MODEL_CHANGE)) {
            advancedParamTableView.setModel((TableModel) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.MEMBRANE_LOCATION)) {
            membraneProfilePanel.setMembraneLocation((Integer) evt.getNewValue());
            membraneProfilePanel.repaint();
        } else if (evt.getPropertyName().equals(CellXController.MEMBRANE_WIDTH)) {
            membraneProfilePanel.setMembraneWidth((Integer) evt.getNewValue());
            membraneProfilePanel.repaint();
        } else if (evt.getPropertyName().equals(CellXController.INFO_MESSAGE)) {
            setNotificationMsg((String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.FLUO_IMAGE_CHANGED)) {
            fluoImageTF.setText((String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.FLAT_FIELD_IMAGE_CHANGED)) {
            flatFieldImageTF.setText((String) evt.getNewValue());
        }
        repaint();
    }

    private synchronized void modelPropertyChangeImagePanelMode(Mode mode) {
        zoomImagePanel.setMode(mode);
        shapesList.setEnabled(true);
        if (mode.equals(Mode.ZOOM_PAN)) {
            zoomAndPanBtn.setSelected(true);
            //shapesList.clearSelection(); 
            shapesList.setModel(new DefaultListModel());
            shapesList.setEnabled(false);
        } else if (mode.equals(Mode.MEMBRANE_PROFILE)) {
            membraneProfileBtn.setSelected(true);
        } else if (mode.equals(Mode.CROP)) {
            cropBtn.setSelected(true);
        } else if (mode.equals(Mode.SEED_SIZE)) {
            seedSizeBtn.setSelected(true);
        } else if (mode.equals(Mode.CELL_LENGTH)) {
            maxCellLengthBtn.setSelected(true);
        }
    }

    private void initToolbarListener() {
        //toolbar buttons group event       
        final MouseListener l = new MouseAdapter() {

            @Override
            public synchronized void mouseClicked(MouseEvent e) {
                if (e.getSource() == zoomAndPanBtn) {
                    controller.setImagePanelMode(Mode.ZOOM_PAN);
                    if (e.getClickCount() > 1) {
                        shapesList.setModel(new DefaultListModel());
                        shapesList.validate();
                        zoomImagePanel.getShapeOverlay().setOverlayShapeList(null);
                        zoomImagePanel.repaint();
                    }
                } else if (e.getSource() == membraneProfileBtn) {
                    controller.setImagePanelMode(Mode.MEMBRANE_PROFILE);
                } else if (e.getSource() == cropBtn) {
                    controller.setImagePanelMode(Mode.CROP);
                } else if (e.getSource() == maxCellLengthBtn) {
                    controller.setImagePanelMode(Mode.CELL_LENGTH);
                } else if (e.getSource() == seedSizeBtn) {
                    controller.setImagePanelMode(Mode.SEED_SIZE);
                }
            }
        };

        zoomAndPanBtn.removeMouseListener(zoomAndPanBtn.getMouseListeners()[0]);
        zoomAndPanBtn.addMouseListener(l);

        membraneProfileBtn.removeMouseListener(membraneProfileBtn.getMouseListeners()[0]);
        membraneProfileBtn.addMouseListener(l);

        cropBtn.removeMouseListener(cropBtn.getMouseListeners()[0]);
        cropBtn.addMouseListener(l);

        maxCellLengthBtn.removeMouseListener(maxCellLengthBtn.getMouseListeners()[0]);
        maxCellLengthBtn.addMouseListener(l);

        seedSizeBtn.removeMouseListener(seedSizeBtn.getMouseListeners()[0]);
        seedSizeBtn.addMouseListener(l);
    }

    private void initListListener() {

        shapesList.addKeyListener(new KeyAdapter() {

            @Override
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_DELETE || e.getKeyCode() == KeyEvent.VK_BACK_SPACE) {
                    if (!shapesList.isSelectionEmpty()) {
                        controller.deleteSelectedShapes(shapesList.getSelectedIndices());
                    }
                }
            }
        });

        shapesList.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                if (!shapesList.isEnabled()) {
                    return;
                }
                if (e.getButton() == MouseEvent.BUTTON3) {
                    JPopupMenu menue = new JPopupMenu();
                    JMenuItem item = new JMenuItem("Delete");
                    menue.add(item);
                    item.addActionListener(new ActionListener() {

                        @Override
                        public void actionPerformed(ActionEvent e) {
                            controller.deleteSelectedShapes(shapesList.getSelectedIndices());
                        }
                    });
                    menue.show(shapesList, e.getX(), e.getY());
                }
            }
        });

        lsl = new ListSelectionListener() {

            @Override
            public void valueChanged(ListSelectionEvent e) {
                controller.setSelectedShapes(shapesList.getSelectedIndices());
            }
        };

        shapesList.addListSelectionListener(lsl);
    }

    private void initTableViewButtonActionListeners() {

        paramTableView.setAutoButtonHandler(new AutoButtonHandler(controller, paramTableView));


        paramTableView.addActionListenerToDefaultButton(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                final int selectedRow = paramTableView.getSelectedRow();
                final CellXParameter param = CellXGuiConfiguration.getParameters().get(selectedRow);
                controller.setParameter(param.getDefaultValue(), selectedRow);
            }
        });

        advancedParamTableView.addActionListenerToDefaultButton(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                final int selectedRow = advancedParamTableView.getSelectedRow();
                final CellXParameter param = CellXGuiConfiguration.getAdvancedParameters().get(selectedRow);
                controller.setAdvancedParameter(param.getDefaultValue(), selectedRow);
            }
        });

        // advancedParamTableView.addCheckBoxListener(new CLAHECheckBoxListener(controller, advancedParamTableView));

    }

    private void setShapesList(final List<SelectableShape> contents) {
        shapesList.removeListSelectionListener(lsl);
        zoomImagePanel.getShapeOverlay().setOverlayShapeList(contents);
        AbstractListModel lm = new AbstractListModel() {

            @Override
            public int getSize() {
                return contents.size();
            }

            @Override
            public Object getElementAt(int index) {
                return contents.get(index);
            }
        };
        shapesList.setModel(lm);
        shapesList.setSelectedIndices(getSelectedIndices(contents));
        shapesList.addListSelectionListener(lsl);
    }

    public static int[] getSelectedIndices(List<SelectableShape> shapes) {
        ArrayList<Integer> indexes = new ArrayList<Integer>();
        int i = 0;
        for (SelectableShape s : shapes) {
            if (s.isSelected()) {
                indexes.add(i);
            }
            ++i;
        }
        int[] ret = new int[indexes.size()];
        for (i = 0; i < indexes.size(); ++i) {
            ret[i] = indexes.get(i);
        }

        return ret;
    }

    private void setNewImage(BufferedImage bufferedImage) {
        zoomImagePanel.setImage(bufferedImage);
        final Rectangle r = zoomImagePanel.getOptimalBoundsIn(maxWinElongation, maxWinElongation);
        if (r.width > r.height) {
            zoomImagePanel.setBounds(0, 0, r.width, r.height);
        } else {
            zoomImagePanel.setBounds(r);
        }
        Dimension current = imagePanel.getPreferredSize();
        imagePanel.setPreferredSize(new Dimension(current.width, r.height));
        current = centralPanel.getPreferredSize();
        centralPanel.setPreferredSize(new Dimension(current.width, (int) Math.max(chartPanel.getHeight() + r.height + 60, 880)));
        jTabbedPane1.setPreferredSize(centralPanel.getPreferredSize());
        mainScrollPanel.revalidate();
    }

    public void showBatchPanelTab() {
        jTabbedPane1.setSelectedIndex(1);
    }

    public void setNotificationMsg(String msg) {
        notificationLabel.setText(msg);
    }

    private File askXMLFileName() {
        final JFileChooser jfc = new JFileChooser();
        jfc.setMultiSelectionEnabled(false);
        final XMLFileFilter xff = new XMLFileFilter();
        jfc.addChoosableFileFilter(xff);
        jfc.setFileFilter(xff);
        final int ret = jfc.showSaveDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            File f = jfc.getSelectedFile();
            if (!f.toString().endsWith(XMLFileFilter.FILE_EXTENSION) && jfc.getFileFilter() == xff.getFileFilter()) {
                f = new File(f.toString() + XMLFileFilter.FILE_EXTENSION);
            }
            if (f.exists()) {
                final int aw = JOptionPane.showConfirmDialog(this, "File '" + f.toString() + "' exists.\nDo you want to overwrite?", "File exists", JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE);
                if (aw != JOptionPane.OK_OPTION) {
                    return null;
                }
            }
            return f;
        }
        return null;
    }

    public void addControlImageMenuItem(File tmpControlImgFile, String type) {
        controlImageMenu.registerControlImage(tmpControlImgFile, type);
    }

    /**
     *
     * @return false, if something is wrong with the file
     */
    public boolean commitFluoFile() {
        final String f = fluoImageTF.getText().trim();
        if (f.equals("")) {
            controller.setFluoImage(null);
            return true;
        } else {
            final File file = new File(f);
            if (file.exists()) {
                controller.setFluoImage(file);
                return true;
            } else {
                controller.showErrorMessage("Error", String.format("Fluorescence image '%s' does not exist\n", f));
            }
        }
        return false;
    }

    public boolean commitFlatFieldFile() {
        final String f = flatFieldImageTF.getText().trim();
        if (f.equals("")) {
            controller.setFlatFieldImage(null);
            return true;
        } else {
            final File file = new File(f);
            if (file.exists()) {
                controller.setFlatFieldImage(file);
                return true;
            } else {
                controller.showErrorMessage("Error", String.format("Flatfield image '%s' does not exist\n", f));
            }
        }
        return false;
    }

    private Object createAboutDialogEditPane() {
        JEditorPane ep = new JEditorPane("text/html", CellXGuiConfiguration.getInstance().getAboutDialogMessage())
        {
            // LW PATCH: Fix background painting on transparent background 
            protected void paintComponent(Graphics g)
            {
                g.setColor( getBackground() );
                g.fillRect(0, 0, getWidth(), getHeight());
                super.paintComponent(g);
            }
        };
        ep.addHyperlinkListener(new HyperlinkListener() {
            @Override
            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType().equals(HyperlinkEvent.EventType.ACTIVATED)) {
                    try {
                        try {
                            java.awt.Desktop.getDesktop().browse(e.getURL().toURI());
                        } catch (IOException ex) {
                            //Logger.getLogger(CellXView.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    } catch (URISyntaxException ex) {
                        // Logger.getLogger(CellXView.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            }
        });
        ep.setEditable(false);
        ep.setBackground(new Color(0, 0, 0, 0));
        ep.setOpaque(false);
        ep.validate();
        return ep;
    }

    private void initAboutMenu() {
         final JMenuItem aboutMenuItem= new JMenuItem("About"){
            @Override
            public Dimension getMaximumSize() {
                return new Dimension(super.getPreferredSize().width, super.getMaximumSize().height);
            }           
        };   
        aboutMenuItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
               JOptionPane.showMessageDialog(null, createAboutDialogEditPane());
            }
        });
        aboutMenuItem.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
        jMenuBar1.add(Box.createGlue());
        jMenuBar1.add(aboutMenuItem);
    }
}
